/*
*
* Gtk+1.2  Utility routines
* Copyright (C) 2002-2003 by Tito Ragusa <tito-wolit@tiscali.it>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of
* the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* Please read the COPYING and README file!!!
*
* Report bugs to <tito-wolit@tiscali.it>
*
*/
#ifndef	__HAVE_DIALOGWINDOW_
#define	__HAVE_DIALOGWINDOW_    1

/*######################### Start of dialog_window Widget ##########################################################*/

void dialog_callback(GtkWidget *widget, gpointer callback_data )
{
	dialog_retval=atoi(callback_data);
	debug_printf("dialog retval %d\n",dialog_retval);
	gtk_main_quit();
}

int dialog_window(char *title, char *labeltext , int type, int modal_flag, char *third_button_label)
{
	/* type == 3	 three button dialog window */
	/* type == 2    two button dialog window   */
	/* type == 1    one button alert  window   */

	GtkWidget *dialog, *button, *label, *table, *frame, *bbox;

	/* dialog_callback returns "0" for type == 1 , and "1" for type ==  2 || type == 3 */
	dialog = window_create	(380, 180, 2, (title) ? title : "Dialog Window",
									dialog_callback,(type==1)?"0":"1",
									modal_flag);
	table = table_create( 6, 6, dialog, 0);

	frame = frame_create_on_table( NULL, table, 0, 6, 0, 5);
	label = label_create_on_table(labeltext, table, 0, 6, 0, 5);

	debug_puts(labeltext);

	bbox = default_button_box_create_on_table( HORIZONTAL, table, 0, 6, 5, 6);

	/* type == 1 || type ==2 */
	button = button_create_in_container((type==1)?"Ok":"Yes", dialog_callback, "0", bbox);
	if(type>=2)
	{
		button = button_create_in_container("No", dialog_callback, "1", bbox);
		if(type==3)
			button = button_create_in_container(third_button_label,dialog_callback, "2", bbox);
	}

	gtk_widget_show_all(dialog);
	gtk_main();
	gtk_widget_destroy(dialog);
	return dialog_retval;
}

/*######################### End of dialod_window Widget   ##########################################################*/

#endif
