/*
*
* Gtk+1.2  Utility routines
* Copyright (C) 2002-2003 by Tito Ragusa <tito-wolit@tiscali.it>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of
* the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* Please read the COPYING and README file!!!
*
* Report bugs to <tito-wolit@tiscali.it>
*
*/
/*#################################### File Selection Widget #####################################################*/

#include "mylib.h"
#include <stdio.h>

void file_sel_ok(GtkWidget *widget, GtkFileSelection *file_selection)
{
	debug_puts("file_sel_ok()");
	selected_path=(char*)xmalloc(strlen(gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_selection)))+1);
	sprintf(selected_path,"%s",gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_selection)));
	gtk_main_quit();
}

char *file_selector(char *title, int fileop, char *ptr)
{
	debug_puts("file_selector()");

	/* we only want to open one file selection window at once */
	if(file_sel_win==NULL)
	{
		file_sel_win = gtk_file_selection_new(title);

		if(fileop==HIDE_FILE_OP_BUTTONS)
			gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(file_sel_win));
		/* else*/
		/*	show file operation buttons (default) */

		/* window placement policy */
		gtk_window_position(GTK_WINDOW(file_sel_win), GTK_WIN_POS_MOUSE);

		gtk_signal_connect(GTK_OBJECT(file_sel_win),
		 "delete_event",GTK_SIGNAL_FUNC(gtk_main_quit), &file_sel_win);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_sel_win)->ok_button),
			"clicked", GTK_SIGNAL_FUNC(file_sel_ok), file_sel_win);
		gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_sel_win)->cancel_button),
			"clicked", GTK_SIGNAL_FUNC(gtk_main_quit), &file_sel_win);

		gtk_widget_show(file_sel_win);
		gtk_main();

		gtk_widget_destroy(file_sel_win);
		/* reset file_sel_win to NULL */
		file_sel_win=NULL;

		/* Something was selected */
		if(selected_path)
		{
			debug_printf("strlen(selected_path): %d\n",strlen(selected_path));
			ptr=(char*)xmalloc(strlen(selected_path)+1);
			sprintf(ptr,"%s",selected_path);
			free(selected_path);
			selected_path=NULL;
			return ptr;
		}
		/* else nothing was selected  return NULL */
	}
	return ptr=NULL;
}

/*############################### End of File Selection Widget #####################################################*/

