/*
*
* Gtk+1.2  Utility routines
* Copyright (C) 2002-2003 by Tito Ragusa <tito-wolit@tiscali.it>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2 of
* the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* Please read the COPYING and README file!!!
*
* Report bugs to <tito-wolit@tiscali.it>
*
*/

#include <gtk/gtk.h>
#include "mylib.h"

/********************* Text file viewer Widget *******************************/

void textview_window_create(char * title,int x, int y, int border, int modal_flag, FILE *fd, char *ptr)
{
	GtkWidget	*edit_window,
					*table,
					*text,
					*button;

	char *temp=NULL;

	debug_puts("textview_window()");

	if(x<=0)x=530;
	if(y<=0)y=430;
	if(border<8)border=8; /* Needed for the scrollbars */

	edit_window = window_create(x, y, border, title, gtk_main_quit, NULL ,modal_flag);
	table = table_create(18, 20 , edit_window , 0);
	text = textpad_create_on_table(NOT_EDITABLE, NULL, WRAP, SCROLL, table,  0, 19, 0, 16);

	if(ptr!=NULL)
	{
		/* Read from ptr and ignore fd */
		gtk_text_insert(GTK_TEXT(text), NULL, &text->style->black, NULL, ptr, -1);
	}
	else
	{
		/* Read from fd */
		if(fd==NULL)
		{
			dialog_window("Alert", "Can't open file!", ONE_BUTTON, MODAL, NULL);
			gtk_widget_destroy(edit_window);
			return;
		}
		else
		{
			temp=fgetc_buf(fd);
			gtk_text_insert(GTK_TEXT(text), NULL, &text->style->black, NULL, temp, -1);
			free(temp);
		}
	}

	button = button_create_on_table("Ok", gtk_main_quit, NULL, table, 16,19, 17,18);

	gtk_widget_show_all(edit_window);
	gtk_main();
	gtk_widget_destroy(edit_window);
	return;
}

/***************End of Text file viewer Widget ********************************/

